#include <bits/stdc++.h>

using namespace std;

struct Projekat{
    long long pocetak;
    long long kraj;
    long long amount;
};

Projekat projekti[200010];
long long dp[200010];

bool cmp(Projekat a, Projekat b){
    return a.kraj < b.kraj;
}

int main()
{
    int n;
    cin >> n;
    for(int i = 1; i <= n; i++)
        cin >> projekti[i].pocetak >> projekti[i].kraj >> projekti[i].amount;

    sort(projekti + 1, projekti + n + 1, cmp);

    dp[1] = projekti[1].amount;

    for(int i = 2; i <= n; i++){
        long long akouzmemo = -1;
        long long akoneuzmemo = -1;

        // 1. slucaj - uzimamo i-ti projekat
        int l = 1;
        int r = i - 1;
        int poslednji = -1;
        while(l <= r){
            int mid = (l + r) / 2;
            if(projekti[mid].kraj < projekti[i].pocetak){
                poslednji = mid;
                l = mid + 1;
            }
            else
                r = mid - 1;
        }
        if(poslednji != -1){
            akouzmemo = dp[poslednji] + projekti[i].amount;
        }
        else
            akouzmemo = projekti[i].amount;

        // 2. slucaj - ne uzimamo i-projekat
        akoneuzmemo = dp[i - 1];

        dp[i] = max(akoneuzmemo, akouzmemo);
    }

    cout << dp[n];

    return 0;
}
