#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 1010;
long long Min[MAXN][MAXN], Max[MAXN][MAXN];

int main() {
    int n;
    cin >> n;
    
    vector<long long> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        Min[i][i] = a[i];
        Max[i][i] = a[i];
    }

    for (int duzina = 1; duzina < n; duzina++) {
        for (int i = 0; i + duzina < n; i++) {
            int j = i + duzina;
            Min[i][j] = Min[i][i] - Max[i + 1][j];
            Max[i][j] = Max[i][i] - Min[i + 1][j];
            for (int k = i + 1; k < j; k++) {
                Max[i][j] = max(Max[i][j], Max[i][k] - Min[k + 1][j]);
                Min[i][j] = min(Min[i][j], Min[i][k] - Max[k + 1][j]);
            }
        }
    }

    cout << Min[0][n - 1] << endl;

    return 0;
}